# ChangeLog

## v0.5.20

### Bug修复

- *(windows)* Console无法打印中文 (#515)

### 杂项

- *(assets)* 删除未使用素材
- 微调日志格式

___

## v0.5.15 ~ v0.5.18

补充只有独立服务端才提供的那些功能。

task功能。

武将牌素材更换。

---

## v0.5.14 & v0.5.13

加了点素材。

修复了一些bug。尤其是下载拓展包相关

Qt升级到6.8，安卓openssl升级到3.1.8

---

## v0.5.11

将底层通信从基于json line的改为基于cbor流的

另外开了repo专门抠服务端，以后这里仅做协议上的同步

___

## v0.5.10

- 服务器启动时可选rpc模式
- 修复libgit2的bug，以及适配1.9.1版（某些地方不能用宏了）
- 修复房间过时后无差别封禁参赛人员与旁观者的bug

___

## v0.5.8

新增了更新拓展包时的ui（主要是C++上的传信号方式）

并且更新freekill-core后提示客户端必须重启

以后应该不太会动版本号了

___

## v0.5.6 && v0.5.7

辛苦各位的重构！这段时间确实付出了很大的精力

因为战线拖太长不知道更新了哪些

___

## v0.5.5

此为不稳定版本。
主要变动详见 https://github.com/Qsgs-Fans/freekill-core/pull/55

- 增强单元测试命令行参数，可只测试一个文件。
- 游戏结束对话框增强。

___

## v0.5.3 & v0.5.4

- 修复服务端若干的bug
- 服务端新增若干命令：stat, lsroom, killroom, msgroom
- 服务端新增限制单设备注册数量的配置key: maxPlayersPerDevice
- 可以查看和复制房间中的禁将
- 新增命令行参数--testskills 可用于运行技能测试例

___

## v0.5.1 & v0.5.2

修bug

___

## v0.5.0

在前面几个版本的bug基本解决后加一个中版本号。

好了我们继续来看AI怎么弄，这一块就是纯lua了

___

## v0.4.21 & v0.4.22 & v0.4.23

- 修复了确认键亮起时取消键不可用的bug
- lua端的ob属性根本没同步，同步一下
- [需要C++] 让requestTimer的超时影响到Lua
- 修复windows没图标
- 移除了modmaker
- 修理了选卡器
- 修理了确定取消消失
- 删除了已经不用的autoPending和respond_play
- 修复异常烧条（或许吧）
- 修复负数烧条时间，若为负数则无事发生
- 修改了定期刷新状态技UI的时机
- 录像可以看别人牌了

___


## v0.4.20

- 重构了UI逻辑
- 重构了客户端隐藏信息的处理
- 旁观不会看到手牌和身份了
- 牌局内可查看一览
- 新增了明置牌概念 以及相关状态技
- 新增了筛选房间功能
- 新增拖动手牌排序
- 新增技能times

___

## v0.4.19

- 修改加入服务器界面，新增服务器列表（暂不会自动更新）
- 观星美化
- 优化了Linux服务器端操作，修复了正在输入的文字被log淹没，新增Tab补全
- Windows开服现在也可以拥有最基本的shell功能

___

## v0.4.18

- 修复掉线仍在读条的bug
- 修复国战单亮副将导致UI失常的bug

___

## v0.4.16 & v0.4.17

在引入freekill-core之后的第一次版本更新，甚至无法保证这次更新是否正常

UI是半成品，0.4.17修复各种爆炸以及半成品UI稍微人性化一点

1. 改进processPrompt，支持双将和暗将
2. 副将长名旋转
3. 国战体力上限优化，包括一览和选将框
4. 空格添加结束出牌阶段，Escape键呼出菜单
5. 武将一览左栏文本换行
6. 同名替换影响已选择的武将
7. 再次排序手牌时按照点数排序
8. Logic.js翻译
9. 进入房间翻译删去句号，跟房间内其他toast风格统一
10. 常见疑问最后一张“下一条”改为“OK!”
11. 录像回放“从文件打开”翻译
12. interaction自动弹出和关闭，comboBox补技能名
13. 卡牌音效添加装备效果音效和使用音效，小小重构
14. activeSkill的prompt的selected_targets实装
15. 禁用扩展包文本ui限制长度
16. 右键技能呼出气泡
17. 搬运了ArrangeCards。
18. 优化了GuanxingBox的操作
19. 修复了不能及时更新技能prompt的bug
20. 取消目标后会刷新目标选择
21. 完备了借刀的牌名
22. CPP代码进行大的重构，配有少量文档
23. （底层）调度机制大改
24. 大厅UI开始调整，但是仍未完工

___

## v0.4.13 & 14 & 15

- 优化重连逻辑
- 客户端代码大量删除JSON。可能影响部分拓展
- 各种修bug

___

## v0.4.12

- 修前个版本poxi框bug
- 增强lcall，可以传更复杂的参数（Object）
- 处理区的牌不会消失 需要FIXME
- 可以屏蔽旁观者
- 可以开启0.2.0时代的卡牌旋转了

___

## v0.4.11

- 给carditem增加dragging参数；
- filterskill在mute的情况下不播放技能特效；
- 给ActiveSkill增加no_indicate参数
- 回合开始时、结束时这两个时机当前回合角色的phase设置为Player.None
- 给usecard增加noIndicate参数
- 服务端热更新功能
- 国战选将框动态显示珠联璧合（等待更清晰的图…）
- 废除和恢复区域log
- 搬运isMale，isFemale，compareDistance，hasShownSkill
- hasSkill如果是状态技，判断是否亮出，未亮出的返回false
- 标准包调整，修复八卦阵，离间结姻用isMale
- 亮将技能改用&后缀并详细化prompt
- 拼点移动起点改为owner
- 使用牌filter改为owner
- 改造常备主逻辑，现在常备主会根据可用多余将数调整
- 改良了getCardArea
- 重新启用将框不足提醒
- 修复了司马懿问打出牌的bug
- 修复了白名单武将不存在时无法创房的bug

___

## v0.4.10

- Github新增自动发布Docker镜像的CI
- 一些覆盖面约为0的lua test，以及基于纯Lua的命令行版本FreeKill
- 为findParent添加深度限制参数(默认无限制)
- 搬运了damageByCardEffect
- 修复了ex__choose_skill
- 修复了华佗、吕蒙和古锭刀
- 添加势力映射，可以指定一个势力必须变成其他几个势力之一（需要神话再临包/OL包自行处理神将变将范围）
- askForCardsChosen界限突破，改成了基于askForPoxi的格式
- 修复了空城虚拟杀可以方天的bug
- 给强制平局添加了原因提醒
- 优化了移动牌的视觉逻辑
- 单机下简单的热更新功能，bug可能极多

___

## v0.4.8 & v0.4.9

- Qml: 新增leval函数可获得lua表达式的值
- 新增AbstractRoom类 去除冗余
- 修gameOver相关bug（或许）
- 从Utility那里搬运了askForYiji和doYiji两个函数，负责分配
  虽然暂时没实现单烧条，但先这么用着
- 修复了askForCardAndPlayers的选择中可以选择复数张牌的bug
- 为prohibitDiscard添加了输入id选项
- 正式添加对多后缀标记的支持
- 添加了一点注释
- 搬运了moveCardIntoEquip和canMoveCardIntoEquip
- 为选牌的默认prompt添加了目标
- 完善了朱雀羽扇的判定
- 修复了抽选武将牌堆时未删除已选武将的bug
- 修复了maxCard标记不识别“-turn”以外标记的bug
- 修复了obtaincard实际不能接受id数组的bug
- CardItem一律可长按，除了卡牌一览
- Qml Mark在QML中可获得主人的id
- Qml Mark可实现某某视角完全不可见
- 隐藏#开头的pile
- 可自定义interaction了
- LogMessage新增toast成员
- 修复投降杀人bug

___

## v0.4.6 & v0.4.7

- 攻击范围状态技类新增基础值修正函数
- 伤害值在一个技能处理后小于1会终止当前事件
- 不向不能使用【无懈可击】的角色询问使用【无懈可击】
- 修正在濒死插结中有人死亡后仍然会向该角色求桃的情况
- 将PreCardUse和PreCardRespond时机移至实体牌移动之前
- 调整改判函数原判定牌置入弃牌堆的原因
- 修正【朱雀羽扇】、【借刀杀人】、【酒】
- 为使用流程和Aim流程增加属性additionalEffect，用于指定额外结算次数（OL版），顺带移动【五谷丰登】开启和关
闭AG的位置；
- 为视为技新增after_use方法处理转化牌后的后续操作；
- 修复伤害流程时机触发者不变问题；
- 修复旁观休整的问题；
- 修复可移动场上牌判断函数未判断虚拟牌名的问题。
- 修复传入数组的extraPile无法收回
- 被弃置牌的log添加操作者
- beforeMaxHpChanged的num可以被修改
- 额外回合增加skillName
- 修复亮将技能和禁止亮将
- 水一些注释和格式
- git报错优化
- 防止反复shutdown同一事件
- 将Utility如canUseCardTo的一些函数搬运到了本体
- 为技能添加hooked_piles属性，当失去技能时自动弃置hooked_piles内的所有私人牌堆
- 修复了添加技能没写source_skill的bug
- 修复了ActiveSkill的interaction不传入Skill本身而是metatable的bug
- 修复了主动询问canUse时没有传入extra_data的bug
- 修复了多选时按钮选项变回空白的bug
- 修复了判定阶段被中途拿走判定牌后报错的bug

___

## v0.4.4 & 0.4.5

禁将增强；修复bug

UsableSkill的expand_pile功能加强

___

## v0.4.3

1. 事件栈和实际的函数调用栈分离
2. 2v2选将专用的MiniGame
3. 各种小修小补

___

## v0.4.2 && v0.4.1

1. 修复和完善qml mark
2. 修复国战野心家放副将
3. 统计游戏时长功能
4. 后台也开始记录注册时间和上次上线的时间
5. 现在会将屏蔽玩家保存到本地并标红提示
6. askForChooseCardsAndPlayers又写崩了，故修之
7. 修复了Within系列没有检查to的错误
8. 彻底修复了连环起点属性的bug

___

## v0.4.0 && v0.3.14

修复bug，详见git log

- 新增canPindian，禁止技新增prohibitPindian

___

## v0.3.13

为v0.4做准备的测试版。

1. 修正标准版武将、卡牌结算
2. 杀光侧栏 只留战报一个
3. Qml标记，以及一个割圆demo
4. 自由选将增加搜索功能
5. room:setBanner，相当于公共标记了
6. 改掉两个很蠢的命名
7. 重做目标参数相关：
8. 重修`must_targets`参数，必须选择其中**全部**目标后才能选择其他目标/按确定
9. 添加`include_targets`参数，必须选择其中**一个**目标后才能选择其他目标/按确定
10. 修复expandPile指定牌堆无卡符合要求则收回的bug
11. 优化ex_choose_skill，添加扩展牌堆和包括装备功能
12. 添加ReasonRecast理由，现在recastCard会返回该动作后摸的牌
13. 移除了重复的DamageFinished时机触发
14. 卡牌一览中音效播放（装备牌鸽）
15. 修改游戏桌面菜单式样，增加音量
16. 卡牌使用时prompt
17. 比较角色性别是否相同
18. 修一些函数提示
19. getEventsOfScope找不到start_event直接返回
20. 应用all_card_types
21. 修改askForCard的默认返回值
22. 增加装备牌技能触发log
23. phase_state初始化
24. 额外阶段走phaseChanging
25. 亮将增加一个时机并做调整（但还是不对……）
26. 标准包和军争篇增加卡牌prompt，修改描述
27. 运用一些Util，hasSkill精简
28. 修改一些神秘英语单词，水
29. 新增船新“休整”机制；
30. 修改作废逻辑，并可在当前响应读条禁用该技能（出牌阶段空闲时间点尚未完成限制）；
31. 修复锁视技的相关bug，其cardFilter新增标识是否为判定的参数；
32. 将护甲扣减融合进体力扣减流程，为伤害流程增加“虚拟伤害”概念，为伤害流程增加“造成过伤害”标识id以供记录搜索使用；
33. 为变将新增可删除副将。
34. 房间内聊天优化。

___

## v0.3.12

Qt框架升级到Qt 6.5.3 LTS版本，安卓告别触控bug。

1. 现在本体支持英文了
2. 修复了prompt看不见extra_data的bug
3. 添加askForChooseBoth用以选择多牌多角色的情况
4. 拆分Util以方便开发插件识别
5. 大招不再显示武将卡面信息
6. 添加勾选框askForCheck，用以提供多选项多选
7. 头像界面更换头像和密码增加计时器
8. 武将界面增加设为头像，搜索框文字输入栏微调
9. 整理手牌将不同的pile分开
10. askForCard(s)Chosen自由prompt
11. 开大动画区分主将副将，特化语音
12. 观星框显示卡牌标记
13. 禁止打出修复
14. random_ai禁止技修复
15. 记录器整局游戏修复
16. 禁止亮将修复封杀已亮的将

___

## v0.3.11

没什么大变化，都是优化

___

## v0.3.10

1. 修录像时间为负数bug
2. 修复域名无法读取服务器信息bug
3. 加入服务器界面的UI稍微优化
4. 大厅聊天的UI稍微优化
5. 添加时机“出牌阶段空闲时间点开始时”，可以在此时设置一些提示性标记
6. 修复请求处理协程只要遇到error直接炸服的bug
7. 添加手牌选择器，能在手牌非常多时帮助玩家选卡
8. 修老朱然bug，现在可以在cleaner环节胆守
9. 修卢弈死了手谈不消失（UI）
10. 修重连时丢失房主信息

(简易AI框架仍在搭建中……暂不上线)

___

## v0.3.9

1. 简易AI框架
2. askForPoxi
3. 修复trigger函数的bug
4. 增加使用和打出的禁止技提示
5. 修复卡牌标记，attach主动技显示为蓝色按钮
6. 增加判断额外回合之法以及fix
7. 修复了询问卡牌时会返回不符合要求的牌的bug
8. 修复了摸牌阶段的skillname（游戏规则）
9. 实装武将牌堆
10. 剥离身份模式特有常备主逻辑
11. 为changeProperty添加时机
12. 分离了改判时的移动
13. 将canUseGeneral改为Engine所属函数
14. 新人教程
15. 国：修复暗将和亮将有关的性别判断
16. 国：上N家和下N家
17. 国：为君主与双势力铺路

___

## v0.3.8

为国战添加专属ui，修复一些bug。

___

## v0.3.7

新老bug一起修复！

这个周末是真的忙

___

## v0.3.5

小测一下，修了bug推个稳定版

___

## v0.3.4

多少也鸽了半个月了，来点体验版

1. 修复木马、真名无懈可击
2. 增加亮将、暗将时机
3. 增加武将珠联璧合关系
4. 增加武将选择框禁止替换
5. 增加变换武将不改变体力上限
6. 增加亮将禁止、不计入距离和座次的MarkEnum，相应的player函数
7. 状态技默认锁定技
8. 修复拼点
9. 增加出牌阶段亮将技能
10. 增加暗置武将函数
11. 修复clone狮子的bug
12. 支持拓展自定义游戏事件
13. 修复反选拓展包时极其卡顿的bug
14. 修复自订身份无法正常显示的bug
15. 谋攻篇askForCard(s)Chosen
16. 修复了倾国时点取消的bug
17. player:broadcastSkillInvoke
18. 修复客户端白名单忘记屏蔽的bug
19. 调教AI
20. 手机不会再自动熄灭

___

## v0.3.3

修复上个版本发现的bug.

___

## v0.3.2

本次更新的主要看点是废除装备栏和判定区。

1. 游戏结束时离线玩家增加逃率
2. 退出房间时取消准备状态
3. 副技能的 `main_skill`
4. 预亮相关优化
5. 自定义身份，图从拓展包随便找一张
6. 无懈可击使用时带1200毫秒延迟
7. 未开始的房间显示开启的所有牌堆，衍生牌灰色字体化
8. 可以随意打开fk.rep文件并播放录像
9. 服务器Shell新增重置密码命令
10. 虚空印卡
11. 15秒踢出房主
12. 各种修bug
13. 图片标记
14. 废除区域

___

## v0.3.1

修复了0.3.0的bug，现在应该是稳定版。

为啥这游戏偶数小版本全都活不长。。

___

## v0.3.0

修复了测试版的诸多bug，更换了一些素材。

___

## v0.2.11

新测试版

- 禁将相关优化，可控制禁将方案
- 遗计
- 常备主公
- 修同名替换可换到隐藏武将bug
- 模式不存在时使用身份模式对局
- 烧条满3次者踢出
- 游戏结束时掉线者受逃跑惩罚
- 作者信息
- 增强谋徐盛
- 修改CardEffecting时机
- 给moveCardTo堆一个proposer
- 修复一些标准版武将和装备
- 修禁止技被视为技绕过的bug

___

## v0.2.10

给0.3预热！这是一个测试版本。不往主服务器更新，因为未经过测试不建议使用。

- 为需要无视描述的请求添加-tmp标签（……）
- 修改铁索相关描述
- 修复了可以通过取消目标以跳过exclusive_targets的bug
- 修复了观星只控顶时还有底部标签的bug
- 修复了没有correct_func时的报错
- 修复了一个人且未分胜负时无限循环的bug
- 将AOE的函数调到了Util内方便其他DIY快速调用
- 将AskForAddTarget转正
- 主动技添加modTargetFilter，负责重新定义目标（借刀摆烂了）
- 游戏模式添加countInFunc(room)，负责检测本局游戏是否可以纳入胜率统计（默认true）
- 录像
- 大招特效

___

## v0.2.9

1. 修重连炸服bug
2. 修距离计算死循环bug
3. 修canUse, skillTimes, exclusived_targets
4. 修复标准版武将的若干bug（不含标郭嘉）
5. 修复%src之类只翻译一次
6. cardMark获得自动清理功能的后缀
7. 类比damage_card，添加标记多目标牌的属性
8. 过长房间名带省略号
9. 封禁设备码
10. 修旁观炸服bug
11. 修旁观炸客户端bug
12. 模式和拓展包之间黑名单白名单
13. 添加了更多nil注释
14. 为选项框增加all_choices，可以看到无法选择的选项
15. 体力上限减到0以下不会再死两次
16. 预判超量回复
17. 可以在摸牌前事件打断摸牌
18. 修复卡牌可以使用判断
19. 添加移动场上牌的返回值（卡牌和玩家id）
20. 修复谋徐盛的属性伤害
21. 修改选择多张牌的翻译
22. 修复变更武将的hp设置
23. 修复出牌阶段高亮显示
24. 修复客户端无法获知他人的阶段
25. 为双头武将提供了特殊的适配，拓展包作者可选
26. 修无懈可击响应的明显延迟
27. 增加了类似木牛流马的机制
28. 封装神将选择势力
29. 修复可以选到主公的副将
30. 完善移动场上一张牌移动虚拟牌及选框中显示逻辑，并增加排除特定卡牌id的参数
31. 多目标锦囊牌询问无懈时新增“本轮忽略”功能
32. 修复传导伤害额外传导自身的问题

___

## v0.2.8

修复测试0.2.7途中获得的bug。

___

## v0.2.7

1. 胜率直接写在脸上
2. 逃跑封禁20min
3. 屏蔽发言功能
4. 新的登陆界面
5. 快速短语
6. 投降，牌序
7. 房间列表手动刷
8. 修bug

___

## v0.2.6

新功能：

* 可以用cardMark在牌上写字了，目前没有提供任何自动清理措施
* 没用的托管按钮改成了反选按钮
* 新增“酒杯”交互表情

bug修复：

* 修复pattern相关的bug
* 修复锁视串房bug
* 拼点牌套壳了一层虚拟牌
* 修复客户端cost_data等

值得注意的地方：

使用卡牌之前会根据锁视技重新决定使用的卡牌；因此锁视技只判断手牌的话必然失效！

___

## v0.2.5

修复了堆积如山的bug

___

## v0.2.4

又一周过去了

1. 修武将一览死亡语音bug
2. 在线人数不足10时播报上下线
3. askfordiscard禁止编辑已传入的maxNum/minNum
4. getSuitString可以返回符号
5. 添加getSuitCompletedString，可显示完整的 **花色+点数**
6. Dockerfile，有需要的就用用吧
7. 可用武将不足时不可创房并警告
8. 修复帷幕能被挂闪的bug
9. 【杀】的限制更多
10. 无目标AOE不可以被使用
11. 主动技可以传更详细的ComboBox
12. 新增exclusive_targets，可限定使用牌的目标(优先级高于一切目标筛选)
13. 多线程改为协程调度器
14. 给interaction喂nil或者空choices可以禁止出interaction小黑框
15. 可以给主动技/视为技上prompt
16. 装备的技能现在会独立显示在最下方
17. 顶号机制，登陆账号时会使同名账号下线
18. 创房时可以全选或者反选
19. 修复重连重置限定技bug以及若干与旁观有关的bug
20. 同步拓展包时若hash相同，则自动跳过
21. 对局中可查看胜率、逃率
22. 武将一览现在可以根据名字搜索武将

___

## v0.2.3

啥也没干，光修bug去了

1. 修事件记录器查询
2. 修安卓没法退出
3. 修某些秘密选人播放指示线
4. 修安卓不能正常退出
5. 修不保存密码
6. 修复技能失效bug，增加可令非锁定技失效的全局标记
7. 修谋徐盛太脆皮bug
8. 修神貂蝉bug
9. 修弃牌阶段可以取消跳过bug
10. 各种或小或大的优化
11. hasMark标记为即将删除

___

## v0.2.2

1. 增加退出时确定
2. 修因心跳引起的贯石斧飞刀
3. 修标记区遮住宝物牌
4. exchangePile (我还没仔细测试)
5. 事件记录器与相应的查找函数
6. Qml/JS大部分let能改的都改成const了，顺便修一些三等号bug
7. 增加hasMark函数，等效于getMark ~= 0
8. 复活
9. 修正cancelable默认
10. move私有牌的-1时其他人视角正常
11. 处理区的牌增加脚注和转化牌牌名（未完全完善）
12. askForChoices堆一个detailed参数以显示详情
13. 武将一览界面上新播放语音
14. 服主可以指定违禁词汇表

___

## v0.2.1

大引流之后的第一次更新。感觉很仓促。

1. 扣上限心碎
2. 进服维护的各种跟后端稳定性有关的代码
3. 断线重连/旁观时候计入技能次数
4. ban人和banip，相应的也有解禁
5. 开房设置现在可以滑动
6. 完善网络错误报错
7. 现在开始游戏之前需要等待和所有人准备
8. 指示掉线之人和走小道之人
9. 掉线和走小道的人不再被AI接管
10. 延时锦囊牌素材从拓展包找
11. 拓展包管理界面UI优化，下载失败的包可以在管理拓展包中删除
12. 手牌上限显示：体力值为负数和手牌上限为无限时显示优化
13. 观星新增提示，修复观星
14. 手牌上限技中，增加不计入手牌上限技
15. 修复变更武将
16. 修复奸雄和救援
17. 修复选角色的cancelble
18. 增强谋徐盛

___

## v0.2.0

修复了标准版吕布属性杀不触发无双、貂蝉决斗可被无懈。

由于标准包更加完善了，所以增加一位中版本号。

1. 获得了中文名“新月杀”
2. 房间可设置密码
3. 手牌上限不等于HP时会显示
4. 修禁用铁锁无法重铸
5. 修视为技按钮一直亮着
6. 使命技机制，完善游戏逻辑
7. 拖孩

___

## v0.1.9

1. 实现移动场上一张牌
2. 实现用作记录牌名并可查看的mark
3. 将askForChoice和interaction的文本解析方式改为prompt
4. 新增属性将牌移至牌堆指定索引位置
5. 修改时机“游戏开始时”至正确位置
6. 优化衍生牌逻辑
7. 新增“卡牌展示后”时机
8. 修改qml文件结构
9. 新增手气卡机制
10. 新增大厅表情功能
11. 新增选将时技能描述查看，以及查看卡牌描述的功能
12. 查看角色技能描述侧栏新增“送花”和“砸蛋”功能

___

## v0.1.8

1. 实现禁将功能
2. 实现转换技，新增发动转换技动画
3. 分离觉醒技的觉醒条件
4. 封装不同实例卡牌的花色、点数、颜色的比较，用于处理无花色等情况
5. 新增mark_enum.lua用于注册通用标记名
6. 实现将特定实现列表按结算顺序排序的函数
7. 允许UI解析值为数组的标记
8. 初步实现不加入牌堆中的衍生卡牌（待改进）

___

## v0.1.7

1. 增加最大选将18
2. 将退出房改为延迟按钮
3. 修虚拟闪电bug
4. 修看破bug
5. 增加长度限制
6. 将异步模块单独一个Lua
7. 修大厅卡死尸体
8. 修“已经有人登入”
9. 修服务端翻译文件
10. 增加出牌时间设置
11. 修Linux下复制文件bug
12. 再次尝试wasm
13. 增加双势力
14. 实现副势力概念，用于应对双势力机制
15. 完善神将及拥有副势力的武将开局选择势力的机制
16. 完成势力技概念
17. 实现ViewAsSkill在响应时对使用和打出的区分

___

## v0.1.6

1. 修复聊天系统
2. 修复拼点bug
3. 加入声音设置
4. 优化自由选将

___

## v0.1.5

1. 控制他人
2. 观星增加限制参数
3. 修野心家bug
4. 修死人连锁/翻面bug
5. 修中闪电不传导
6. 禁止技也影响视为技等等
7. 火攻交互优化

___

## v0.1.4

看点：

1. 国战
2. 旧版朱然

修bug内容：

1. 游戏规则优先级bug
2. 插入新阶段
3. 蜀护驾改魏护驾
4. 为card也增加了mark，但尚不实用

___

## v0.1.3

1. 优化了武将一览和卡牌一览的UI。
2. 增强exppattern
3. 引入调试器，在Lua代码中调用`dbg()`可以下断点
4. 修复cloneCard未复制is_damage_card

___

## v0.1.2

一次更小的更新。

1. 修复单机启动闪退
2. 公告也发送到聊天里面
3. 上线/下线时发送公告

___

## v0.1.1

一次小更新。

主要看点：

1. 双将
2. 旁观者聊天、大厅聊天优化
3. 对局中显示牌堆数和轮数

详细：

1. 修检验md5失效
2. 修因心跳包导致整个游戏停跳的bug
3. 增加主公技配音和台词
4. 修一些和TargetMod有关的bug
5. 修发送语音时显示undefined的bug
6. 增加服务端广播消息功能
7. 优化游戏Log机制
8. 开启服务端读config的接口备用
9. 修复倾国响应时点击技能按钮会直接取消出闪的bug
10. 优化标记文本的显示
11. 修只有一张子卡的虚拟牌没花色
12. 为无花色牌显示他的颜色

___

## v0.1.0

标准包终于完结！版本号也随机升了一位

主要新机制：

1. 主公技
2. 护甲机制
3. AES加密通信

新机制：

1. 添加武将相关技能
2. 添加武将中性和无性
3. 给Card堆一个伤害牌属性
4. 能添加虚拟牌为子卡
5. 封装了“视为使用xx牌”的函数
6. 护甲机制
7. interaction现在可以作为一个函数，以实现动态化
8. 冰属性伤害
9. 使用牌堆中的牌不再报错

修bug：

1. 修流离锁定技
2. 修斧子弃自己
3. 修顺手空城卡死
4. 修旁观者id是自己的
5. 修旁观者再开新局就闪退（或许吧）
6. 修拼点报nil
7. 修询问无懈时旁观者被卡在外面
8. 修Room的请求队列不清理干净

___

## v0.0.8

1. 禁止使用打出弃置
2. 为FilterSkill加player参数
3. 对局中可查看他人技能
4. GameEvent相关设施
5. 添加时机或事件：轮次
6. 以-round等方式结尾的标记会被自动清理，详见源码
7. 增加了NixOS用的构建脚本

修bug：

1. 流离bug
2. 觉醒技显示方式反过来
3. 询问无懈时100% CPU占用
4. skill.interaction无效
5. 装备从自己装备区移动到别人
6. 觉醒技cost和锁定技不一样
7. 狮子给死人加血
8. 拖曳体验差
9. 暂时禁用旁观功能，bug太多
10. 【杀】的distance_limit_func无效bug

___

## v0.0.7

1. 文档已经上线，内容应该是很多的，就是没写完
2. 重新设计了Card.skillName，并给各种cloneCard补上了skillName（仅限于FK核心涉及的）
3. 给好几个交互加个cancelable/prompt参数，把prompt美化了一下
4. 为老周泰做了一些耦合
5. 点击私人牌堆的名字可以弹出牌数量了，而不是一堆数字
6. 主动技/视为技能借助额外的UI交互以提前收集更多数据，可用于泛转化
7. 限定技/觉醒技在Photo上显示的UI
8. 修复了kingdom属性没有被实际赋值的bug
9. 移动了equipIcon的素材位置
10. 移动力kingdom相关素材的位置，现在可以在mod中自订势力
11. 大厅内显示在线人数，大厅内聊天
12. 心跳包机制，防掉线和卡在服务器
13. 服务端shell现在可以踢人

___

## v0.0.6

1. 修bug
2. 增加个更多展示移动牌的log
3. 同名武将替换
4. UI更新
5. 补全所有卡牌

___

## v0.0.5

1. 五谷丰登和酒
2. 开房可自选游戏模式，可拓展游戏模式
3. 开房可自选开启的拓展包
4. 安全性加强
5. 支持拼点
6. 修bug

___

## v0.0.4

Tag: v0.0.4

1. 制作了军争包大部分卡牌
2. 在计算完md5后立刻删除flist.txt
3. 修bug
4. 将摸初始牌和执行回合计入事件中
5. 允许使用-DFK_SERVER_ONLY宏来编译不含GUI支持的版本
6. 避免每次启动都复制资源文件

___

## v0.0.3

Tag: v0.0.3

大改动：

1. 重写事件体系，参考[doc/dev/gameevent.md](./doc/dev/gameevent.md)
2. 增加私人牌堆交互功能，可以写出像邓艾这样的武将了
3. 增加了五谷选牌框，但未实装
4. 八卦阵和“无双”
5. 添加了询问同时选择一名玩家多张牌的交互

小改动：

1. 修复选牌框bug
2. Android版的应用数据从内部存储转移到外部存储
3. Win版exe现在有图标了

___

## v0.0.2

Tag: v0.0.2

较大变动：

1. 添加了更多文档，包括DIY的基本文档
2. 完成了大多数装备，除了八卦阵、青釭剑
3. 完成了标准包技能：离间,流离
4. 添加了对玩家私人牌堆的支持
5. 修复了Libgit2相关的bug，从此拓展包同步更加正确快捷
6. 添加了在拓展包中通过QML任意指定交互方式的办法
7. 重构了ActiveSkill中和feasible有关的部分，不过旧版风格的直接指定feasible函数仍然有效
8. AI框架完工，初步制作了随机型AI（哪里亮了点哪）
9. 初步支持国际化，将一些东西翻译成了英文

小变动：

1. 编译安卓时，不再把rsa密钥也打包进去
2. 不让lua服务端进入死循环，当等待时间充足时睡眠10ms
3. 将lua/vscode更名为lua/lsp，并针对类的静态函数加入了补全信息
4. 将检测房间是否没有活人的环节移动到AI处理事项之前
5. 装修了一下README
6. 修一堆bug
